(*
** some basic definitions 
**
** these are taken from /home/alti/lego/newLib to keep the proof
** self contained.
*)

(* composition *)

[o[B,C|Type][f:B->C][A|Type][g:A->B] = [a:A]f (g a)];

(* iff is reflexiv & transitive *)

Goal {A:Prop}iff A A;
intros;andI;intros;Immed;intros;Immed;
Save iff_refl;

Goal {A,B,C:Prop}(iff A B)->(iff B C)->(iff A C);
intros;Refine H;intros;Refine H1;intros;andI;
intros;Refine H4;Refine H2;Immed;intros;Refine H3;Refine H5;Immed;
Save iff_trans;

(*
** Definition of Martin-L"of equality & 
** the proof of some properties
*)

(* [A|Set]mu[EQ:A->A->Set](EQ_refl:{a:A}EQ a a) *)

[A|Set]
$[EQ : A->A->Set]
$[EQ_refl : {a:A}EQ a a]
$[RecEQ : {C:{a,b|A}(EQ a b)->Type}
	      ({a:A}C (EQ_refl a))
	      -> {a,b|A}{p:EQ a b}C p];

[[C:{a,b|A}(EQ a b)->Type][f0:{a:A}C (EQ_refl a)]
 [a:A]
   RecEQ C f0 (EQ_refl a) ==> f0 a];

Discharge A;

[A,B|Set];

[EQ_trans [a,b,c|A][p1:EQ a b][p2:EQ b c] =
	(RecEQ ([a,b|A][_:EQ a b](EQ b c) -> (EQ a c))
	   ([a:A][p:EQ a c]p)
	   p1) p2 : EQ a c];

[EQ_sym [a,b|A][p:EQ a b] =
	RecEQ ([a,b|A][_:EQ a b]EQ b a)
	  ([a:A]EQ_refl a)
	  p : EQ b a];

[EQ_resp [f:A->B][a,b|A][p:EQ a b] =
	RecEQ ([a,b|A][_:EQ a b]EQ (f a) (f b))
	  ([a:A]EQ_refl (f a))
	  p : EQ (f a) (f b)];

[EQ_rewrite [a,b|A][p:EQ a b][P:A->Type] =
	RecEQ ([a,b|A][_:EQ a b](P a)->(P b))
	  ([a:A][p:P a]p)
	  p : (P a) -> (P b)];
[EQ_rewrite'[a,b|A][p:EQ a b] = EQ_rewrite (EQ_sym p)];

Discharge A;

Configure Qrepl EQ EQ_rewrite EQ_sym;

Goal {A|Set}{c:A}{C:{a|A}(EQ a c)->Set}
		(C (EQ_refl c))->{a|A}{p:EQ a c}C p;
intros;
Claim  {a,c|A}{q:EQ a c}{C:{a|A}(EQ a c)->Set}(C (EQ_refl c))
  -> C q;
Refine ?+1; Refine H;
Refine RecEQ [a,c|A][q:EQ a c]
	{C:{a|A}(EQ a c)->Set}(C (EQ_refl c))->C q;
intros;Refine H1;
Save RecEQ1;

(* 
** some basic datatypes 
*)

(*** mu[Unit:Set](void:Unit) ***)

[Unit : Set]
[void : Unit]

[RecUnit : {P:Unit->Type}(P void)->{x:Unit}P x];

[[P:Unit->Type][f0:P void]
   RecUnit P f0 void ==> f0];

[RecUnitN[P|Type] = RecUnit ([_:Unit]P) : P->Unit->P];

(*** mu[Nat:Set](zero:Nat,succ:Nat->Nat) ***)

[Nat : Set]
[zero : Nat][succ : Nat->Nat]

[RecNat : {P:Nat->Type}
          (P zero)->({n:Nat}(P n)->(P (succ n)))
          -> {n:Nat}P n];

[[P:Nat->Type][z:P zero][f:{n:Nat}(P n)->(P (succ n))][n:Nat]
    RecNat P z f zero ==> z
 || RecNat P z f (succ n) ==> f n (RecNat P z f n)];

[RecNatN[C|Type] = RecNat ([_:Nat]C)];

(*  add : nat -> Nat -> Nat
rec add zero n = n
  | add (succ m) n = succ (add m n)
*)
[add = RecNatN ([n:Nat]n)
	       ([m:Nat][add_m:Nat->Nat][n:Nat]succ (add_m n))];

Goal {m,n:Nat}EQ (add m (succ n)) (succ (add m n));
Refine RecNat [m:Nat]{n:Nat}EQ (add m (succ n)) (succ (add m n));
intros _;Refine EQ_refl;
intros;Refine EQ_resp succ;Refine H;
Save add_succ_lem;

(* mu[LE:Nat->Nat->Set](
	LE0:{n:Nat}LE zero n,
        LE1:{m,n|Nat}(LE m n) -> (LE (succ m) (succ n)))
*)

[LE:Nat->Nat->Set]
[LE0:{n:Nat}LE zero n]
[LE1:{m,n|Nat}(LE m n) -> (LE (succ m) (succ n))]
[RecLE:{C:{m,n|Nat}(LE m n)->Set}
	   ({n:Nat}(C (LE0 n)))
	-> ({m,n|Nat}{p:LE m n}(C p) -> C (LE1 p))
	-> {m,n|Nat}{p:LE m n}C p];

[[C:{m,n|Nat}(LE m n)->Set][f0:{n:Nat}(C (LE0 n))]
 [f1:{m,n|Nat}{p:LE m n}(C p)->C (LE1 p)]
 [m,n:Nat][p:LE m n]
   RecLE C f0 f1 (LE0 n) ==> f0 n 
|| RecLE C f0 f1 (LE1 p) ==> f1 p (RecLE C f0 f1 p)];

[RecLEN[C:Nat->Nat->Set] = RecLE ([m,n:Nat][_:LE m n]C m n)];

(* mu[Fin:Nat->Set](f_zero:{n:Nat}Fin (succ n),
		    f_succ:{n:Nat}(Fin n)->(Fin (succ n))) *)

[Fin : Nat -> Set]
[f_zero : {n:Nat}Fin (succ n)]
[f_succ : {n|Nat}(Fin n) -> (Fin (succ n))]
[RecFin : {P:{n|Nat}(Fin n)->Type}
	     ({n:Nat}P (f_zero n)) ->
	     ({n|Nat}{m:Fin n}(P m) -> (P (f_succ m))) ->
	     {n|Nat}{m:Fin n}P m];

[[P:{n|Nat}(Fin n)->Type][f0:{n:Nat}P (f_zero n)]
 [f1:{n|Nat}{m:Fin n}(P m) -> (P (f_succ m))]
 [k:Nat][m:Fin k]
    RecFin P f0 f1 (f_zero k) ==> f0 k
 || RecFin P f0 f1 (f_succ m) ==> f1 m (RecFin P f0 f1 m)];

[RecFinN [C:Nat->Type] = RecFin ([n|Nat][_:Fin n]C n)
 : ({n:Nat}C (succ n))
 ->({n|Nat}(Fin n)->(C n)->C (succ n))
 ->{n|Nat}(Fin n)->C n];

[Fin2Nat = RecFinN ([_:Nat]Nat) 
		([_:Nat]zero)
		([n|Nat][_:Fin n]succ)];

[RecFinZero [P:(Fin zero)->Type][i:Fin zero] =
	[P'[k|Nat] = RecNat ([m:Nat](Fin m)->Type)
		([i:Fin zero]P i)
		([m:Nat][_:(Fin m)->Type][_:Fin (succ m)]Unit) k]
	RecFin P' ([_:Nat]void) ([n|Nat][i:Fin n][_:P' i]void) i
 : P i];

[RecFinZeroN[P:Type] = RecFinZero ([_:Fin zero]P)
	: (Fin zero)->P];

[RecFinSucc [P:{n|Nat}(Fin (succ n))->Type]
	[f0:{n:Nat}P (f_zero n)][f1:{n|Nat}{m:Fin n}P (f_succ m)]
	[n|Nat][i:Fin (succ n)] =
	[P'[k|Nat] = RecNat ([m:Nat](Fin m)->Type)
		([_:Fin zero]Unit)
		([m:Nat][_:(Fin m)->Type]P|m) k]
	RecFin P' f0 ([n|Nat][i:Fin n][_:P' i]f1 i) i
 : P i];

[RecFinSuccN[P:Nat->Type] = RecFinSucc ([n|Nat][_:Fin (succ n)]P n)];
	
Goal {n|Nat}{P:(Fin (succ n))->Set}
	(P (f_zero n))
	->({i:Fin n}P (f_succ i))
	->{m:Fin (succ n)}P m;
intros;
Claim {n|Nat}{m:Fin (succ n)}{P:(Fin (succ n))->Set}
	(P (f_zero n))->({i:Fin n}P (f_succ i))->(P m);
Refine ?+1;Immed;
Refine RecFinSucc [n|Nat][m:Fin (succ n)]{P:(Fin (succ n))->Set}
	  (P (f_zero n))->({i:Fin n}P (f_succ i))->(P m);
intros;Refine H2;
intros;Refine H3;
Save RecFin1;

[RecFin1N [n:Nat][P|Set] = RecFin1 ([_:Fin (succ n)]P)
 :  P->((Fin n)->P)->(Fin (succ n))->P];

(* [A:Set]mu[Vec:Nat->Set](v_nil:Vec zero,
			   v_cons:A->{n|Nat}(Vec n)->(Vec succ n)) *)

[Vec : Set->Nat -> Set]
[v_nil : {A:Set}Vec A zero]
[v_cons : {A|Set}A -> {n|Nat}(Vec A n) -> (Vec A (succ n))]

[RecVec : {A|Set}{P:{n|Nat}(Vec A n)->Type}
          (P (v_nil A)) -> 
          ({a:A}{n|Nat}{l:Vec A n}(P l) -> (P (v_cons a l))) ->
          {n|Nat}{l:Vec A n}P l];

[[A:Set][P:{n|Nat}(Vec A n)->Set]
 [n:P (v_nil A)][f:{a:A}{n|Nat}{l:Vec A n}(P l) -> (P (v_cons a l))]
  [a:A][k:Nat][v:Vec A k]          
    RecVec P n f (v_nil A) ==> n
 || RecVec P n f (v_cons a v) ==> f a v (RecVec P n f v)];

[A,B|Set];

[RecVecN [P:Nat->Type] = RecVec ([n|Nat][_:Vec A n]P n)
 : (P zero)->(A->{n|Nat}(Vec A n)->(P n)->P (succ n))->{n|Nat}(Vec A n)->P n];
[RecVecNN [P|Type] = RecVecN ([n:Nat]P)
 : P->(A->{n|Nat}(Vec A n)->P->P)->{n|Nat}(Vec A n)->P];

[RecVecSucc [P:{n|Nat}(Vec A (succ n))->Type]
	[f1:{a:A}{n|Nat}{v:Vec A n}P (v_cons a v)]
	[n|Nat][v:Vec A (succ n)] =
	[P' = RecNat ([i:Nat](Vec A i)->Type) 
		([_:Vec A zero]Unit)
		([i:Nat][_:(Vec A i)->Type]P|i)]
	RecVec P' void ([a:A][j|Nat][v:Vec A j][_:P' j v]f1 a v) v : P v];
[RecVecSuccN [P:Nat->Type] = RecVecSucc ([n|Nat][_:Vec A (succ n)]P n)];

Goal {n|Nat}{P:(Vec A (succ n))->Set}
	  ({a:A}{l:Vec A n}P (v_cons a l))
	->{m:Vec A (succ n)}P m;
intros;
Claim {n|Nat}{l:Vec A (succ n)}{P:(Vec A (succ n))->Set}
	({a:A}{l:Vec A n}P (v_cons a l)) -> (P l);
Refine ?+1;intros;Refine H;
Refine RecVecSucc [n|Nat][l:Vec A (succ n)]
	{P:(Vec A (succ n))->Set}({a:A}{l1:Vec A n}P (v_cons a l1))->P l;
intros;Refine H1;
Save RecVec1;

[v_hd = RecVecSuccN ([_:Nat]A) ([a:A][n|Nat][_:Vec A n]a) 
      : {n|Nat}(Vec A (succ n)) -> A];
[v_tl = RecVecSuccN (Vec A) ([_:A][n|Nat][v:Vec A n]v)
      : {n|Nat}(Vec A (succ n)) -> (Vec A n)];

DischargeKeep A;

(* v_nth : {n|Nat}(Fin n)->(Vec A n)->A

rec v_nth|(succ n) (f_zero n) = v_hd|A|n
  | v_nth|(succ n) (f_succ i) = o (v_tl|A|n) (v_nth i)
*)

[v_nth = RecFinN ([n:Nat](Vec A n)->A) (v_hd|A)
		([n|Nat][_:Fin n][f:(Vec A n)->A]o f (v_tl|A|n))];

[v_map [f:A->B] = 
  RecVec ([i|Nat][_:Vec A i]Vec B i)
	(v_nil B) ([a:A][i|Nat][_:Vec A i][v:Vec B i]v_cons (f a) v)];

[v_append =
  [P[n:Nat]={m|Nat}(Vec A m)->(Vec A (add n m))]
  RecVecN P ([m|Nat][v:Vec A m]v)
	([a:A][n|Nat][_:Vec A n][f:P n]
	 [m|Nat][v:Vec A m]v_cons a (f v))
  : {n|Nat}(Vec A n)->{m|Nat}(Vec A m)->(Vec A (add n m))];

(*

v_insert : {m,n|Nat}(Vec A m)->A->(Vec A n)->(Vec A (succ (add m n)))

v_insert v_nil a v2 = v_cons a v2
v_insert b::v1 a v2 = v_cons b (v_insert v1 a v2)

*)

[v_insert [m,n|Nat][v1:Vec A m][a:A][v2:Vec A n] =
	RecVecN ([m:Nat]Vec A (succ (add m n)))
	  (v_cons a v2)
	  ([b:A][m|Nat][v1:Vec A m][v_insert_v1:Vec A (succ (add m n))]
		v_cons b v_insert_v1)
	  v1];

Discharge A;

(* We repeat all definitions we did for Vec for large Vectors (VEC) ! *)

(* [A:Type(0)]mu[VEC:Nat->Type(0)](v_nil:VEC zero,
			   v_cons:A->{n|Nat}(VEC n)->(VEC succ n)) *)

[VEC : Type(0) ->Nat -> Type(0)]
[V_nil : {A:Type(0)}VEC A zero]
[V_cons : {A|Type(0)}A -> {n|Nat}(VEC A n) -> (VEC A (succ n))]

[RecVEC : {A|Type(0)}{P:{n|Nat}(VEC A n)->Type}
          (P (V_nil A)) -> 
          ({a:A}{n|Nat}{l:VEC A n}(P l) -> (P (V_cons a l))) ->
          {n|Nat}{l:VEC A n}P l];

[[A:Set][P:{n|Nat}(VEC A n)->Set]
 [n:P (V_nil A)][f:{a:A}{n|Nat}{l:VEC A n}(P l) -> (P (V_cons a l))]
  [a:A][k:Nat][v:VEC A k]          
    RecVEC P n f (V_nil A) ==> n
 || RecVEC P n f (V_cons a v) ==> f a v (RecVEC P n f v)];


[A,B|Type(0)];

[RecVECN [P:Nat->Type] = RecVEC ([n|Nat][_:VEC A n]P n)
 : (P zero)->(A->{n|Nat}(VEC A n)->(P n)->P (succ n))->{n|Nat}(VEC A n)->P n];
[RecVECNN [P|Type] = RecVECN ([n:Nat]P)
 : P->(A->{n|Nat}(VEC A n)->P->P)->{n|Nat}(VEC A n)->P];

[RecVECSucc [P:{n|Nat}(VEC A (succ n))->Type]
	[f1:{a:A}{n|Nat}{v:VEC A n}P (V_cons a v)]
	[n|Nat][v:VEC A (succ n)] =
	[P' = RecNat ([i:Nat](VEC A i)->Type) 
		([_:VEC A zero]Unit)
		([i:Nat][_:(VEC A i)->Type]P|i)]
	RecVEC P' void ([a:A][j|Nat][v:VEC A j][_:P' j v]f1 a v) v : P v];
[RecVECSuccN [P:Nat->Type] = RecVECSucc ([n|Nat][_:VEC A (succ n)]P n)];

Goal {n|Nat}{P:(VEC A (succ n))->Set}
	  ({a:A}{l:VEC A n}P (V_cons a l))
	->{m:VEC A (succ n)}P m;
intros;
Claim {n|Nat}{l:VEC A (succ n)}{P:(VEC A (succ n))->Set}
	({a:A}{l:VEC A n}P (V_cons a l)) -> (P l);
Refine ?+1;intros;Refine H;
Refine RecVECSucc [n|Nat][l:VEC A (succ n)]
	{P:(VEC A (succ n))->Set}({a:A}{l1:VEC A n}P (V_cons a l1))->P l;
intros;Refine H1;
Save RecVEC1;

[V_hd = RecVECSuccN ([_:Nat]A) ([a:A][n|Nat][_:VEC A n]a) 
      : {n|Nat}(VEC A (succ n)) -> A];
[V_tl = RecVECSuccN (VEC A) ([_:A][n|Nat][v:VEC A n]v)
      : {n|Nat}(VEC A (succ n)) -> (VEC A n)];

DischargeKeep A;

[V_nth = RecFinN ([n:Nat](VEC A n)->A) (V_hd|A)
		([n|Nat][_:Fin n][f:(VEC A n)->A]o f (V_tl|A|n))];

[V_map [f:A->B] = 
  RecVEC ([i|Nat][_:VEC A i]VEC B i)
	(V_nil B) ([a:A][i|Nat][_:VEC A i][v:VEC B i]V_cons (f a) v)];


[V_append =
  [P[n:Nat]={m|Nat}(VEC A m)->(VEC A (add n m))]
  RecVECN P ([m|Nat][v:VEC A m]v)
	([a:A][n|Nat][_:VEC A n][f:P n]
	 [m|Nat][v:VEC A m]V_cons a (f v))
  : {n|Nat}(VEC A n)->{m|Nat}(VEC A m)->(VEC A (add n m))];

[V_insert [m,n|Nat][v1:VEC A m][a:A][v2:VEC A n] =
	RecVECN ([m:Nat]VEC A (succ (add m n)))
	  (V_cons a v2)
	  ([b:A][m|Nat][v1:VEC A m][V_insert_v1:VEC A (succ (add m n))]
		V_cons b V_insert_v1)
	  v1];

Discharge A;
